﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.801
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	' Эти глобальные переменные будут объявлены один раз при запуске приложения.
	' Эти переменные могут быть доступны из всех модулей.
	' подключение серверных слассов
	Public link As String = "http://192.168.0.104"                ' активный адрес  Ноды
	Public meNetAdress  As String ="nullClient.world"              ' собственный сетевой дарес (имя) клиента
	Public MeNetPassword As String = "client"                      ' собственный сетьевой пароль клиента
	
	Public JG As JSONGenerator	
	Public BC As ByteConverter
	Public su As StringUtils
	
	Private recipientIp  As String=""                              ' ip -адрес текущего адресата
	Private newMailsCount As Int                                   ' число не полученных сообщений
	Private newMail As String                                      ' последнее полученное сообщение
	
	Private NodeTimerInterval As Int = 2000  ' интервал обновления в милисекундах
	Private NodeTimer As Timer  ' таймер подтверждения связи с Нодой
	
	' подключение шифрования
	Private ClientPW As String
	Private EncDec As AESEncryption
	Private MyPublicRSAKeyAsBytes() As Byte, MyPrivateRSAKeyAsBytes() As Byte
	Private  ForeignPublicRSAKeyAsBytes() As Byte
	
	'Private C1 As B4XCipher
	Private C  As Cipher
	Private ForeignKPG, OwnKPG As KeyPairGenerator
	
	
	' работа с Базой Данных
	'Private SQL As SQL
	Private Const DBName As String = "ManifestStore.db"
	
	' доставка сообщений
	Public Mailer As Mailer

End Sub

Sub Service_Create
	' Это точка входа в программу.
    ' Это хорошее место для загрузки ресурсов, которые не относятся к конкретному виду деятельности. 
	
	'Создаем базу данных и Открывает базу данных - если её еще нет
	If Not(File.Exists(File.DirDefaultExternal, DBName)) Then
		'SQL.Initialize(File.DirDefaultExternal, DBName, True)
	    ' При первом создании БД, создаем все таблицы:
		
		
		
	Else
		' Иначе, если БД есть, то просто открывает базу данных
		'SQL.Initialize(File.DirDefaultExternal, DBName, False)
   End If

End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StopAutomaticForeground 'Стартовый сервис может запускаться в основном состоянии в некоторых крайних случаях.
	EncDec.Initialize
	Mailer.Initialize
	
	' запустить таймер
	NodeTimer.Initialize("updateIp",  60 * NodeTimerInterval) '2 minutes
	NodeTimer.Enabled = True
	NodeTimer_Tick
	
End Sub

Sub Service_TaskRemoved
	'Это событие возникает, когда пользователь удаляет приложение из списка последних приложений.
End Sub

'Верните true, чтобы обработчик исключений по умолчанию ОС мог обрабатывать необработанное исключение.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy
  
End Sub


'  таймер запросов к  Ноде
Sub NodeTimer_Tick
	Dim j As HttpJob
	j.Initialize("checkmail" , Me)
	j.Download2(link  & "/update", Array As String("type", "checkmail", _
	                                               "sendadress",meNetAdress, _
	                                               "inadress", "node", _
												   "password",MeNetPassword))
End Sub


'  отправка сообщения 
Sub  SendMessage(message As String)
	Dim j As HttpJob
	j.Initialize("msg", Me)
	j.PostString(link & "?type=text&inadress=", message)
End Sub

 
' отправка файла 
Sub SendFile (Dir As String, FileName As String) 
		Dim j As HttpJob
		Dim out As OutputStream
		out.InitializeToBytesArray(0)
		Dim In As InputStream = File.OpenInput(Dir, FileName)
		File.Copy2(In, out)
		
		Dim lastSlash As Int = FileName.LastIndexOf("/")
		If lastSlash > -1 Then
			FileName = FileName.SubString(lastSlash + 1)
		End If
		Dim su As StringUtils
		Dim j As HttpJob
		j.Initialize("file", Me)
		j.PostBytes(link & "?type=file&name=" & su.EncodeUrl(FileName, "UTF8"), _
			out.ToBytesArray) 
End Sub

' обработка ответа  Ноды
Sub JobDone(j As HttpJob)
	If j.Success Then
		'ToastMessageShow("Success: " & j.GetString, False)
		Log("Success: " & j.GetString)
		Dim ret As Map
		ret.Initialize
		Dim JSON As JSONParser
		JSON.Initialize(j.GetString)
		ret = JSON.NextObject
		
		Select Case j.JobName
			Case "checkmail"  ' получить количество не доставленной  кореспонднции
				newMailsCount = ret.Get("value")
			Case "getip"      ' Получить динамический ip адресата
				recipientIp = ret.Get("value")
			Case "getmail"    ' Получить очередное сообщение от Ноды
				newMail  = ret.Get("value")
		End Select
	Else
		'ToastMessageShow("Error: " & j.ErrorMessage, True)
		Log("Error: " & j.ErrorMessage)
	End If
	j.Release
End Sub

' ---------------   RSA - шифрование  -------------------- 
' создание пары ключей
Sub GenerateOWNRSAKeys
	' C.Initialize("RSA/ECB/PKCS1Padding")
	OwnKPG.Initialize("RSA", 2048)
	OwnKPG.GenerateKey
	MyPrivateRSAKeyAsBytes=OwnKPG.PrivateKeyToBytes
	MyPublicRSAKeyAsBytes=OwnKPG.PublicKeyToBytes
End Sub

' пролучение публичного ключа в форме строки
Sub GetOwnPublicKey()As String
	Dim MyMap As Map
	MyMap.Initialize
	MyMap.Put("Action","PubKey")
	MyMap.Put("PubKey",su.EncodeBase64(MyPublicRSAKeyAsBytes))
	JG.Initialize(MyMap)
	Log("Sending own Public Key")
	Return JG.ToString   ' .GetBytes("UTF8")
End Sub

' RSA - шифрование вновь сгенерированного  AES -пароля  в форме пригодной для отправки
Sub MakeAsePassword() As String
	Dim PWC As String = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890!§$%&/()=?{[]}\+#-"
	For i=0 To 49
		ClientPW=ClientPW & PWC.CharAt(Rnd(0,PWC.Length))
	Next
	
	Dim MyMap As Map
	MyMap.Initialize

	MyMap.Put("Action","Password")
	MyMap.Put("Password",su.EncodeBase64(C.Encrypt(ClientPW.GetBytes("UTF8"),ForeignKPG.PublicKey,False)))
	JG.Initialize(MyMap)
	Log("Sending Password")
		
	Return JG.ToString
End Sub

' Дешифрация RSA -публичного ключа
Sub DecodePublicKey(MyMap As Map)
	ForeignPublicRSAKeyAsBytes=su.DecodeBase64(MyMap.Get("PubKey"))
	ForeignKPG.Initialize("RSA", 2048)
	ForeignKPG.PublicKeyFromBytes(ForeignPublicRSAKeyAsBytes)
End Sub

' дешифрация ASE -пароля шифрования
Sub DecodePassword(MyMap As Map)
	ClientPW=BC.StringFromBytes(C.Decrypt(su.DecodeBase64(MyMap.Get("Password")), OwnKPG.PrivateKey,False),"UTF8")
End Sub


' ----------------  AES -шифрование   --------------------
' шифрование
Sub AES_Encrypt(text As String, IV As String) As String
	EncDec.InitializationVector =IV  ' "Q.6qYq0_C+mGmymX" 'Must be 16 characters in length
	EncDec.SecretKey = ClientPW          ' "3hba8fOumOPrMG0.G?-mkF-scGOkPwyW" 'Must be 16 or 32 characters in length
	Return EncDec.AESEncrypt(text)
End Sub

' дешифрация
Sub AES_Decrypt(text As String, IV As String) As String
	EncDec.InitializationVector =IV  ' "Q.6qYq0_C+mGmymX" 'Must be 16 characters in length
	EncDec.SecretKey = ClientPW          ' "3hba8fOumOPrMG0.G?-mkF-scGOkPwyW" 'Must be 16 or 32 characters in length
	Return EncDec.AESDecrypt(text)	
End Sub
